/*****************************************************************************

        RectalAnarchyTrack.h
        By Laurent de Soras, 2001

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (RectalAnarchyTrack_HEADER_INCLUDED)
#define	RectalAnarchyTrack_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



class RectalAnarchy;
class RectalAnarchyChannel;

class RectalAnarchyTrack
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

						RectalAnarchyTrack ();
	virtual			~RectalAnarchyTrack ();

	void				init (RectalAnarchy &mch, float sample_freq);
	void				note_on (float midi_note, float slide_time);
	void				note_off ();
	void				dissociate_channel ();
	int				get_midi_note () const;

	void				set_velo (float velo);

	void				load (CMachineDataInput * const pi);
	void				save (CMachineDataOutput *const po);



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

	class TrackParameters
	{
	public:
		float			_velo;
	};

	void				allocate_channel ();

	RectalAnarchy*	_mch_ptr;
	float				_sample_freq;
	int				_midi_note;
	RectalAnarchyChannel *				// Channel used by the last played note.
						_channel_ptr;
	TrackParameters
						_track_param;



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

						RectalAnarchyTrack (const RectalAnarchyTrack &other);
	RectalAnarchyTrack &
						operator = (const RectalAnarchyTrack &other);
	bool				operator == (const RectalAnarchyTrack &other) const;
	bool				operator != (const RectalAnarchyTrack &other) const;

};	// class RectalAnarchyTrack



//#include	"RectalAnarchyTrack.hpp"



#endif	// RectalAnarchyTrack_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
