/*****************************************************************************

        archi_def.h

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (archi_archi_def_HEADER_INCLUDED)
#define	archi_archi_def_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#if defined (__MWERKS__)
#include	<MacTypes.h>
#endif

#if defined (__BEOS__)
#include	<SupportDefs.h>
#include	<ByteOrder.h>
#endif

#include	<climits>

// compiler defines
#define	archi_COMPILER_CLASS_STD	(1)
#define	archi_COMPILER_CLASS_VC		(2)
#define	archi_COMPILER_CLASS_CW		(3)
#define	archi_COMPILER_CLASS_GCC	(4)
#define	archi_COMPILER_CLASS_ICC	(5)

// Keep compiler versions in ascending order
#define	archi_COMPILER_STD			(1)
#define	archi_COMPILER_UNKNOWN		(2)
#define	archi_COMPILER_VC6			(3)
#define	archi_COMPILER_VC7			(4)
#define	archi_COMPILER_VC8			(5)
#define	archi_COMPILER_CW7			(6)
#define	archi_COMPILER_CW8			(7)
#define	archi_COMPILER_CW9			(8)
#define	archi_COMPILER_GCC2			(9)
#define	archi_COMPILER_GCC3			(10)
#define	archi_COMPILER_GCC4			(11)
#define	archi_COMPILER_ICC10			(12)

// Systeme
#if defined (__BEOS__)
 	#define	archi_SYS_BE
#elif defined (WIN32) || defined (_WIN32)|| defined (__INTEL__)
	#define	archi_SYS_WIN
#elif defined (MAC) || defined (__POWERPC__) || defined (__powerpc) || defined (_powerpc)
	#define	archi_SYS_MAC
#elif defined(__GNUC__) && ( defined(__APPLE_CPP__) || defined(__APPLE_CC__) || defined(__MACOS_CLASSIC__) ) && defined(__i386__) 
	#define	archi_SYS_MACINTEL
#elif defined (__unix__)
	#define	archi_SYS_UNIX
#else
	#error Unsupported operating system.
#endif

// Architecture du processeur
#if defined (__BIG_ENDIAN__)
	#define	archi_BIG_ENDIAN
#elif defined (__LITTLE_ENDIAN__)
	#define	archi_LITTLE_ENDIAN
#elif defined (__BEOS__)
	#if B_HOST_IS_LENDIAN == 1
		#define	archi_LITTLE_ENDIAN
	#elif B_HOST_IS_BENDIAN == 1
		#define	archi_BIG_ENDIAN
	#else
		#error Unsupported processor architecture.
	#endif
#elif defined (WIN32) || defined (_WIN32)|| defined (__INTEL__) || defined (__i386__) || defined (__x86_64__) || defined(__ia64__)
	#define	archi_LITTLE_ENDIAN
#elif defined (MAC) || defined (__POWERPC__) || defined (__powerpc) || defined (_powerpc)
	#define	archi_BIG_ENDIAN
#elif defined (__unix__)
	#error Unsupported processor architecture. You can still define yourself __LITTLE_ENDIAN__ or __BIG_ENDIAN__ in the compiler options.
#endif

// Endian
#if defined (archi_BIG_ENDIAN)
	#define	archi_ENDIAN_VAL	1
#elif defined (archi_LITTLE_ENDIAN)
	#define	archi_ENDIAN_VAL	0
#else
	#error Endian not defined.
#endif



// Native word size, in bits
#if defined (_M_IA64) || defined (_WIN64) || defined (__64BIT__) || defined (__powerpc64__) || defined (__ppc64__) || defined (__x86_64__)
	#define	archi_WORD_SIZE	64
#else
	#define	archi_WORD_SIZE	32
#endif



// Compiler
#if defined (__MWERKS__)

#error compiler is codewarrior!

	#define	archi_COMPILER_CLASS	(archi_COMPILER_CLASS_CW)

	#if ((__MWERKS__ & 0xFF00) == 0x2400)
		#define	archi_COMPILER (archi_COMPILER_CW7)
	#elif ((__MWERKS__ & 0xFF00) == 0x3000)
		#define	archi_COMPILER (archi_COMPILER_CW8)
	#elif ((__MWERKS__ & 0xFF00) == 0x3200)
		#define	archi_COMPILER (archi_COMPILER_CW9)
	#else
		#define	archi_COMPILER (archi_COMPILER_UNKNOWN)
	#endif

#elif defined (__INTEL_COMPILER)
	// icc also defines __GNUC__ in gcc compatibility mode
	#define	archi_COMPILER_CLASS	(archi_COMPILER_CLASS_ICC)

	#if (__INTEL_COMPILER >= 1000) && (__INTEL_COMPILER < 1100)
		#define	archi_COMPILER (archi_COMPILER_ICC10)
	#else
		#define	archi_COMPILER (archi_COMPILER_UNKNOWN)
	#endif

#elif defined (__GNUC__)

	#define	archi_COMPILER_CLASS	(archi_COMPILER_CLASS_GCC)

	#if (__GNUC__ == 2)
		#define	archi_COMPILER (archi_COMPILER_GCC2)
	#elif (__GNUC__ == 3)
		#define	archi_COMPILER (archi_COMPILER_GCC3)
	#elif (__GNUC__ == 4)
		#define	archi_COMPILER (archi_COMPILER_GCC4)
	#else
		#define	archi_COMPILER (archi_COMPILER_UNKNOWN)
	#endif

// Must be checked last, as other compiler could define this symbol.
#elif defined (_MSC_VER)

	#define	archi_COMPILER_CLASS	(archi_COMPILER_CLASS_VC)

	#if ((_MSC_VER / 100) == 12)
		#define	archi_COMPILER (archi_COMPILER_VC6)
	#elif ((_MSC_VER / 100) == 13)
		#define	archi_COMPILER (archi_COMPILER_VC7)
	#elif ((_MSC_VER / 100) == 14)
		#define	archi_COMPILER (archi_COMPILER_VC8)
	#else
		#define	archi_COMPILER (archi_COMPILER_UNKNOWN)
	#endif

#else

	#define	archi_COMPILER_CLASS	(archi_COMPILER_CLASS_STD)
	#define	archi_COMPILER			(archi_COMPILER_STD)

#endif


// Data alignment for type declaration.
// alignsize is the alignment size
// The macro does not add the terminal semicolon.
#if (archi_COMPILER_CLASS == archi_COMPILER_CLASS_VC)
	#define	archi_TYPEDEF_ALIGN( alignsize, typedeclaration)	\
		typedef __declspec (align (alignsize)) typedeclaration

#elif (archi_COMPILER_CLASS == archi_COMPILER_CLASS_CW)
	#error Undefined for this compiler.

#elif (archi_COMPILER_CLASS == archi_COMPILER_CLASS_GCC)
	#define	archi_TYPEDEF_ALIGN( alignsize, typedeclaration)	\
		typedef typedeclaration __attribute__ ((aligned (alignsize)))

#elif (archi_COMPILER_CLASS == archi_COMPILER_CLASS_ICC)
	#define	archi_TYPEDEF_ALIGN( alignsize, typedeclaration)	\
		typedef __declspec (align(alignsize)) typedeclaration
	#warning jno : icc10 does not align a typedef correctly...
#else
	#error Unsupported Compiler.

#endif



// pack align pour BeOS
/* Return nonzero value if sign of X is negative.  */
#if defined (__BEOS__)
	#define pack_align(x)    	__attribute__((aligned(x), packed))
#else
	#define pack_align(x)
#endif



namespace archi
{



#if CHAR_BIT != 8
	#error 'char' type is not 8 bits-wide !
#endif	// CHAR_BIT

typedef	signed char		SByte;
typedef	unsigned char	UByte;



#if USHRT_MAX != 0xFFFF
	#error 'short' type is not 16 bits-wide !
#endif	// USHORT_MAX

typedef	short				Int16;
typedef	unsigned short	UInt16;



#if UINT_MAX != 0xFFFFFFFF
	#error 'int' type is not 32 bits-wide !
#endif	// UINT_MAX

typedef	int				Int32;
typedef	unsigned int	UInt32;



#if defined (_MSC_VER)
typedef	__int64			Int64;
typedef	unsigned __int64	UInt64;
#elif defined (__MWERKS__)
typedef	SInt64			Int64;
#elif defined (__BEOS__)
typedef	int64				Int64;
typedef	uint64			UInt64;
#elif defined (__INTEL_COMPILER)
typedef	long long		Int64;
typedef	unsigned long long	UInt64;
#elif defined (__GNUC__)
typedef	long long		Int64;
typedef	unsigned long long	UInt64;
#else
	#error Not defined for this compiler !
#endif



union Fixed3232
{
	Int64				_all;
	struct
	{
#if defined (archi_LITTLE_ENDIAN)
		UInt32			_lsw;
		Int32				_msw;
#else		// archi_LITTLE_ENDIAN
		Int32				_msw;
		UInt32			_lsw;
#endif	// archi_LITTLE_ENDIAN
	}					_part;
};



typedef	float				Float32;
typedef	double			Float64;



#if defined (_MSC_VER)
#define	archi_FORCEINLINE	__forceinline
#elif defined (__INTEL_COMPILER)
// see -inline-forceinline compiler option
#define	archi_FORCEINLINE	__forceinline
#else
#define	archi_FORCEINLINE	inline
#endif



}	// namespace archi



//#include	"archi/archi_def.hpp"



#endif	// archi_archi_def_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
