/*****************************************************************************

        Array.hpp

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (basic_Array_CODEHEADER_INCLUDED)
#define	basic_Array_CODEHEADER_INCLUDED



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	<cassert>



namespace basic
{



/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



template <class T, long LENGTH>
Array <T, LENGTH>::Array (const Array <T, LENGTH> &other)
{
	for (long pos = 0; pos < LENGTH; ++pos)
	{
		_data [pos] = other._data [pos];
	}
}



template <class T, long LENGTH>
Array <T, LENGTH> &	Array <T, LENGTH>::operator = (const Array <T, LENGTH> &other)
{
	for (long pos = 0; pos < LENGTH; ++pos)
	{
		_data [pos] = other._data [pos];
	}

	return (*this);
}



/*
==============================================================================
Name: operator []
Description:
	Acces to the data array
Input parameters:
	- pos: Data position, in range [0 ; LENGTH [
Returns: A reference on the stored data.
Throws: Nothing
==============================================================================
*/

template <class T, long LENGTH>
const typename Array <T, LENGTH>::Element &	Array <T, LENGTH>::operator [] (long pos) const
{
	assert (pos >= 0);
	assert (pos < LENGTH);

	return (_data [pos]);
}



template <class T, long LENGTH>
typename Array <T, LENGTH>::Element &	Array <T, LENGTH>::operator [] (long pos)
{
	assert (pos >= 0);
	assert (pos < LENGTH);

	return (_data [pos]);
}



template <class T, long LENGTH>
long	Array <T, LENGTH>::size ()
{
	return (LENGTH);
}



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



}	// namespace basic



#endif	// basic_Array_CODEHEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
