/*****************************************************************************

        basic_fnc.h

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (basic_basic_fnc_HEADER_INCLUDED)
#define	basic_basic_fnc_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	"archi/archi_def.h"

#include	<string>
#include	<vector>



namespace basic
{



#if defined (max)	// UGLY!!!
#undef max
#endif
template <class T>
inline T			max (T a, T b);
template <class T>
inline void		max_in_place (T& a, T b);

#if defined (min)	// UGLY!!!
#undef min
#endif
template <class T>
inline T			min (T a, T b);
template <class T>
inline void		min_in_place (T& a, T b);

#if defined (abs)	// UGLY!!!
#undef abs
#endif

template <class T>
inline T			abs (T a);
template <>
inline float	abs (float a);
template <>
inline double	abs (double a);

template <class T>
inline T			limit (T a, T b, T c);

template <class T>
inline void		limit_in_place (T &a, T b, T c);

inline double	round (double x);
inline int		round_int (double x);
inline int		floor_int (double x);
inline int		ceil_int (double x);
template <class T>
inline int		sgn (T x);
inline int		float_to_int_fast (float x);
inline int		float_to_int_fast (double x);
inline int		round_int_fast (float x);

inline double	sinc (double x);
inline double	acosh (double x);
inline double	asinh (double x);
inline double	atanh (double x);
template <class T>
inline T			ipow (T x, long n);
template <class T>
inline T			ipowp (T x, long n);

inline float	fast_log2 (float val);
inline float	fast_exp2 (float val);
inline archi::UInt32	fast_partial_exp2_int_16_to_int_32 (int val);
inline archi::UInt32	fast_partial_exp2_int_16_to_int_32_4th (int val);

inline float	tan_taylor_5th (float val);

inline bool		is_null (double x);
inline bool		is_equal (double x, double y);
inline bool		is_equal_tol (double x, double y, double d);
inline bool		is_equal_delta (double x, double y, double d);
inline bool		is_denormal (const float &f);

inline double	pseudo_exp (double x, double p, double c);
inline double	pseudo_exp2 (double x, double c);
inline double	pseudo_exp10 (double x, double c);
inline double	pseudo_log (double y, double p, double c);
inline double	pseudo_log2 (double y, double c);
inline double	pseudo_log10 (double y, double c);

inline int		get_next_pow2 (long x);
inline int		get_prev_pow2 (long x);
inline bool		is_pow2 (long x);
inline long		conv_int_2_bcd (long x);
inline long		conv_bcd_2_int (long x);
inline double	conv_db_2_lin_p2 (int x);
inline char		conv_digit_2_char (int x);
inline int		conv_char_2_digit (char c);
inline char		change_case (char c, bool lower_case_flag);

template <class T>
inline T			shape_s (T x);
template <class T>
inline T			shape_saturate (T x);
template <class T>
inline T			shape_desaturate (T x);

std::string	gen_string (char c, long n);
std::string	gen_string (const char *str_0, long n);
std::string	gen_string (const std::string &str, long n);
void	print_float (char *dest_0, double val, long max_len);
void	strncpy_0 (char *dest_0, const char *src_0, long buf_len);
void	strncat_0 (char *dest_0, const char *src_0, long buf_len);
bool	str_jump_to_end (const char * & str_0, long & dec);
bool	str_jump_to_end (char * & str_0, long & dec);
inline long	get_strlen (const char *text_0);
long	search_str_ci (const char *s1_0, const char *s2_0);
bool	strcmp_ci (const char *s1_0, const char *s2_0);
const std::string	to_lcase (const std::string &txt);
const std::string	to_ucase (const std::string &txt);
void	to_lcase_inplace (std::string &txt);
void	to_lcase_inplace (char *txt_0);
void	to_ucase_inplace (std::string &txt);
void	to_ucase_inplace (char *txt_0);
int	parse_line (std::vector <std::string> &lex_arr, const char *line_0, const char *delimiter_list_0 = " \n\t\b\v");
bool	is_delimiter (char c, const char *delimiter_list_0);
bool	test_filename (const char *filename_0, const char *mask_0);
void	trim_string (std::string &txt, const char *delimiter_list_0 = " \n\t\b\v");
std::string	compact_string_for_display (const std::string &txt, long max_len, const char *delimiter_list_0 = " \n\t\b\v");

void	decode_compile_date (int &year, int &month, int &day, const char *date_0);



}	// namespace basic



#include	"basic/basic_fnc.hpp"



#endif	// basic_basic_fnc_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
