/*****************************************************************************
*                                                                            *
*       PROJECT NAME                                                         *
*       Version 1.00, 2001/01/01                                             *
*       (c) Ohm Force                                                        *
*                                                                            *
*       AdsrBase.h                                                           *
*       Short file description                                               *
*       Portability/Compatibility                                            *
*                                                                            *
* Tab = 3                                                                    *
*****************************************************************************/



#if defined (dsp_AdsrBase_CURRENT_HEADER)
	#error Recursive inclusion of dsp/AdsrBase header.
#endif
#define	dsp_AdsrBase_CURRENT_HEADER

#if ! defined (dsp_AdsrBase_HEADER_INCLUDED)
#define	dsp_AdsrBase_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma warning (4 : 4250) // "Inherits via dominance."
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



namespace dsp
{



class AdsrBase
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

	enum Section
	{
		Section_NONE,
		Section_ATTACK,
		Section_DECAY,
		Section_SUSTAIN,
		Section_RELEASE,

		Section_NBR_ELT
	};

	enum {			INFINITE_SUSTAIN	= 1999	}; // Sec.
   enum {         MAX_SAMPLE_FREQ   = 0x7FFFFFFFL / INFINITE_SUSTAIN   }; // Hz (currently 1 MHz)

	// All these functions must be implemented in the derived class.
	void				set_sample_freq (float fs);
	void				set_attack_time (float at);
	void				set_decay_time (float dt);
	void				set_sustain_level (float sl);
	void				set_sustain_time (float st);
	void				set_release_time (float rt);
	AdsrBase::Section
						get_cur_section () const;
	void				note_on ();
	void				note_off ();

	void				clear_buffers ();
	void				kill_ramps ();

	float				get_val () const;
	float				process_sample ();
	void				process_block (float data [], long nbr_spl);
	void				process_block_mul (float data [], long nbr_spl);
	void				skip_block (long nbr_spl);



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:



};	// class AdsrBase

}	// namespace dsp



/*\\\ GLOBAL OPERATOR PROTOTYPES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ CODE HEADER INCLUSION \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



#endif	// dsp_AdsrBase_HEADER_INCLUDED

#undef dsp_AdsrBase_CURRENT_HEADER



/*****************************************************************************

	LEGAL

	(c) 2001 Ohm Force

	Use of this file or part of its content without written permission is
	strictly forbidden.
	For more information, please contact Ohm Force at :
	contact@ohmforce.com

*****************************************************************************/



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
