/*****************************************************************************

        FastRand.h

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (dsp_FastRand_HEADER_INCLUDED)
#define	dsp_FastRand_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



namespace dsp
{



class FastRand
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

	enum {			A_VAL		= 1103515245	};
	enum {			B_VAL		= 12345			};
	enum {			M_VAL		= 0x7FFFFFFF	};

	inline			FastRand ();

	inline long		get_new_val ();
	inline long		get_new_val (long nbr_val);
	inline void		set_seed (long val);
	inline void		set_seed_natural ();
	inline void		clear_buffers ();



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

	long				_current_val;



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

						FastRand (const FastRand &other);
	FastRand &		operator = (const FastRand &other);
	bool				operator == (const FastRand &other) const;
	bool				operator != (const FastRand &other) const;

};	// class FastRand



}	// namespace dsp



#include	"dsp/FastRand.hpp"



#endif	// dsp_FastRand_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
