/*****************************************************************************

        Filter2p.h

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (dsp_Filter2p_HEADER_INCLUDED)
#define	dsp_Filter2p_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	"dsp/BiquadS.h"



namespace dsp
{



class Filter2p
:	public BiquadS
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

	typedef	BiquadS	Inherited;

	enum Type
	{
		LOWPASS = 0,
		HIGHPASS,
		RESONATOR,
		BANDPASS,

		NBR_TYPES
	};

						Filter2p ();

	static const char *const
						TYPE_NAME_0 [NBR_TYPES];

	inline void		set_type (Type type);
	inline Type		get_type () const;
	inline void		set_reso (float reso);
	inline float	get_reso () const;
	inline void		set_q (float q);
	inline float	get_q () const;
	void				update_eq ();

	inline void		copy_filter (const Filter2p &other);



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

	Type				_type;
	float				_reso;			// %, > 0
	float				_q;				// %, > 0



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

						Filter2p (const Filter2p &other);
	Filter2p &		operator = (const Filter2p &other);
	bool				operator == (const Filter2p &other) const;
	bool				operator != (const Filter2p &other) const;

};	// class Filter2p



}	// namespace dsp



#include	"dsp/Filter2p.hpp"



#endif	// dsp_Filter2p_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
