/*****************************************************************************

        InterpFncPeriodic.h

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (dsp_InterpFncPeriodic_HEADER_INCLUDED)
#define	dsp_InterpFncPeriodic_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



namespace dsp
{



template <int CYCLE_RES_LOG2, class GenFtor>
class InterpFncPeriodic
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

	enum {			CYCLE_RES			= 1L << CYCLE_RES_LOG2	};
	enum {			CYCLE_MASK			= CYCLE_RES - 1	};

						InterpFncPeriodic ();

	static void		init_coef ();

	float inline	operator () (float x) const;



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

	static float	coef [CYCLE_RES] [4];
	static bool		coef_init_flag;



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

						InterpFncPeriodic (const InterpFncPeriodic &other);
	InterpFncPeriodic &
						operator = (const InterpFncPeriodic &other);
	bool				operator == (const InterpFncPeriodic &other) const;
	bool				operator != (const InterpFncPeriodic &other) const;

};	// class InterpFncPeriodic



}	// namespace dsp



#include	"dsp/InterpFncPeriodic.hpp"



#endif	// dsp_InterpFncPeriodic_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
