/*****************************************************************************

        OnePoleS.h

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (dsp_OnePoleS_HEADER_INCLUDED)
#define	dsp_OnePoleS_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	"dsp/OnePole.h"



namespace dsp
{



class OnePoleS
:	public dsp::OnePole
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

	typedef	dsp::OnePole	Inherited;

						OnePoleS ();
	inline void		copy_filter (const OnePoleS &other);

	inline void		set_sample_freq (float fs);
	inline float	get_sample_freq () const;
	inline void		set_freq (float f0);
	inline float	get_freq () const;
	inline void		set_s_eq (const float b [2], const float a [2]);
	inline void		set_s_eq (const double b [2], const double a [2]);
	inline void		get_s_eq (float b [2], float a [2]) const;
	void				transform_s_to_z ();



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:

	float				_s_eq_b [2];	// Coefficients du numerateur, ordre s^n
	float				_s_eq_a [2];	// Coefficients du denominateur, ordre s^n.



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

	float				_sample_freq;	// Hz, > 0
	float				_f0;				// Hz, > 0, _f0 % (_sample_freq/2) != 0



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

						OnePoleS (const OnePoleS &other);
	OnePoleS &		operator = (const OnePoleS &other);
	bool				operator == (const OnePoleS &other) const;
	bool				operator != (const OnePoleS &other) const;

};	// class OnePoleS



}	// namespace dsp



#include	"dsp/OnePoleS.hpp"



#endif	// dsp_OnePoleS_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
