/*****************************************************************************

        ParamInertia.h

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (dsp_ParamInertia_HEADER_INCLUDED)
#define	dsp_ParamInertia_HEADER_INCLUDED

#if defined (_MSC_VER)
	#pragma once
	#pragma warning (4 : 4250)
#endif



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



namespace dsp
{



class ParamInertia
{

/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

public:

						ParamInertia ();

	inline void		set_inertia_time (float inertia_time);
	inline float	get_inertia_time () const;

	void				set_sample_freq (float fs);
	void				set_val (float val);
	inline void		force_val (float val);	// No inertia
	inline float	get_val () const;
	inline float	get_target_val () const;
	void				tick (long nbr_spl);
	inline bool		is_ramping () const;
   inline void    stop ();
	inline void		clear_buffers ();



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

protected:



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

	float				_inertia_time;	// s
	float				_fs;				// Hz
	float				_old_val;
	float				_new_val;
	double			_cur_val;
	double			_step;			// par sample



/*\\\ FORBIDDEN MEMBER FUNCTIONS \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

private:

						ParamInertia (const ParamInertia &other);
	ParamInertia &	operator = (const ParamInertia &other);
	bool				operator == (const ParamInertia &other) const;
	bool				operator != (const ParamInertia &other) const;

};	// class ParamInertia



}	// namespace dsp



#include	"dsp/ParamInertia.hpp"



#endif	// dsp_ParamInertia_HEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
