/*****************************************************************************

        Shelf.hpp

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*Tab=3***********************************************************************/



#if ! defined (dsp_Shelf_CODEHEADER_INCLUDED)
#define	dsp_Shelf_CODEHEADER_INCLUDED



/*\\\ INCLUDE FILES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	<cassert>



namespace dsp
{



/*\\\ PUBLIC \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*
==============================================================================
Name: copy_filter
Description:
	Copies the filter, without its state.
Input parameters:
	- other: Source filter.
Throws: Nothing
==============================================================================
*/

void	Shelf::copy_filter (const Shelf &other)
{
	Inherited::copy_filter (other);

	_level = other._level;
}



/*
==============================================================================
Name: set_level
Description:
	Sets the shelf level. 1 corresponds to a neutral filtering.
Input parameters:
	- level: Linear shelf level.
Throws: Nothing
==============================================================================
*/

void	Shelf::set_level (float level)
{
	_level = level;
}



float	Shelf::get_level () const
{
	return (_level);
}



/*\\\ PROTECTED \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ PRIVATE \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



}	// namespace dsp



#endif	// dsp_Shelf_CODEHEADER_INCLUDED



/*\\\ EOF \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
